package org.bench4q.agent.scenario.node;

import java.util.ArrayList;
import java.util.Stack;

import org.bench4q.agent.datacollector.DataCollector;
import org.bench4q.agent.scenario.instruction.Instruction;
import org.bench4q.agent.scenario.instruction.TestInstruction;
import org.bench4q.agent.scenario.instruction.TimerInstruction;
import org.bench4q.share.exception.Bench4QRunTimeException;
import org.bench4q.share.models.agent.scriptrecord.BehaviorModel;
import org.bench4q.share.models.agent.statistics.BehaviorBriefModel;

public class TimerBehavior extends PluginImplementBehavior {

	public TimerBehavior(BehaviorModel timerBehaviorModel) {
		if (!timerBehaviorModel.getType().equalsIgnoreCase(
				Behavior.TIMER_BEHAVIOR)) {
			throw new Bench4QRunTimeException(
					"The type is not expected. Expected is TIMER_BEHAVIOR, but it is "
							+ timerBehaviorModel.getType());
		}
		this.buildAndGenerateParameterPart(timerBehaviorModel);
	}

	@Override
	public void compile(ArrayList<Instruction> code,
			Stack<TestInstruction> conditions) {
		code.add(new TimerInstruction(this.getUse(), this.getName(), this
				.getParameters()));
	}

	@Override
	public boolean shouldBeCount() {
		return false;
	}

	@Override
	public BehaviorBriefModel getBehaviorBriefResult(
			DataCollector dataStatistics) {
		return null;
	}
}
