package org.bench4q.agent.scenario.node;

import java.util.ArrayList;
import java.util.Stack;

import org.bench4q.agent.datacollector.DataCollector;
import org.bench4q.agent.scenario.instruction.Instruction;
import org.bench4q.agent.scenario.instruction.SampleInstruction;
import org.bench4q.agent.scenario.instruction.TestInstruction;
import org.bench4q.share.exception.Bench4QRunTimeException;
import org.bench4q.share.models.agent.scriptrecord.BehaviorModel;
import org.bench4q.share.models.agent.statistics.BehaviorBriefModel;

public class UserBehavior extends PluginImplementBehavior {

	public UserBehavior(BehaviorModel behaviorModel) {
		if (!behaviorModel.getType().equalsIgnoreCase(Behavior.USER_BEHAVIOR)) {
			throw new Bench4QRunTimeException(
					"Not the expected type, expected is USER_BEHAVIOR, but is "
							+ behaviorModel.getType());
		}
		buildAndGenerateParameterPart(behaviorModel);
	}

	@Override
	public void compile(ArrayList<Instruction> code,
			Stack<TestInstruction> conditions) {
		code.add(new SampleInstruction(this.getUse(), this.getName(), this
				.getParameters()));
	}

	@Override
	public boolean shouldBeCount() {
		return true;
	}

	@Override
	public BehaviorBriefModel getBehaviorBriefResult(
			DataCollector dataStatistics) {
		BehaviorBriefModel result = (BehaviorBriefModel) dataStatistics
				.getBehaviorBriefStatistics(this.getId());
		return result;
	}

}
