package org.bench4q.agent.test.model;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlElementWrapper;
import javax.xml.bind.annotation.XmlElements;
import javax.xml.bind.annotation.XmlRootElement;

import org.bench4q.share.helper.MarshalHelper;
import org.bench4q.share.models.agent.scriptrecord.BehaviorModel;
import org.bench4q.share.models.agent.scriptrecord.IfBehaviorModel;
import org.junit.Test;

import static org.junit.Assert.*;

@XmlRootElement(name = "modelTest")
public class ModelTest {

	@Test
	public void unmarshalVerify() throws IOException, JAXBException {
		Object object = JAXBContext
				.newInstance(BehaviorModel.class)
				.createUnmarshaller()
				.unmarshal(
						new File("Scripts"
								+ System.getProperty("file.separator")
								+ "behaviorModel.xml"));
		assertTrue(object instanceof BehaviorModel);
	}

	@Test
	public void testMarshalInheritence() {
		Container batchModel = new Container();
		batchModel.behaviorModels.add(new IfBehaviorModel());
		batchModel.behaviorModels.add(new BehaviorModel());
		System.out.println(MarshalHelper.tryMarshal(batchModel));
	}

	@XmlRootElement
	private static class Container {
		@XmlElementWrapper(name = "behaviorModels")
		@XmlElements({
				@XmlElement(name = "behavior", type = BehaviorModel.class),
				@XmlElement(name = "ifBehavior", type = IfBehaviorModel.class) })
		private List<BehaviorModel> behaviorModels = new ArrayList<BehaviorModel>();

	}
}
