package org.bench4q.master.unitTest.datastatistics;

import java.util.ArrayList;

import org.bench4q.master.domain.valueobject.datastatistics.impl.BehaviorsBriefStatistics;
import org.bench4q.share.helper.MarshalHelper;
import org.bench4q.share.models.agent.statistics.AgentBehaviorsBriefModel;
import org.bench4q.share.models.agent.statistics.BehaviorBriefModel;
import org.bench4q.share.models.agent.statistics.BehaviorStatusCodeResultModel;
import org.bench4q.share.models.master.statistics.ScriptBehaviorsBriefModel;
import org.junit.Test;

public class Test_BehaviorsBriefStatistics {
	@Test
	public void testAddNull() {
		BehaviorsBriefStatistics behaviorsBriefStatistics = new BehaviorsBriefStatistics();
		AgentBehaviorsBriefModel dataUnit = new AgentBehaviorsBriefModel();
		String url = "www.baidu.com";
		dataUnit.getBehaviorBriefModels().add(
				buildBehaviorBriefModel(1, url, 2, 3));
		dataUnit.getBehaviorBriefModels().add(
				buildBehaviorBriefModel(1, url, 3, 5));
		behaviorsBriefStatistics.add(dataUnit);
		ScriptBehaviorsBriefModel result = behaviorsBriefStatistics
				.getStatistics();
		System.out.println(MarshalHelper.tryMarshal(result));

	}

	private BehaviorBriefModel buildBehaviorBriefModel(int behaviorId,
			String url, int successCount, int totalCount) {
		BehaviorBriefModel e = new BehaviorBriefModel();
		e.setBehaviorId(behaviorId);
		e.setBehaviorUrl(url);
		e.setDetailStatusCodeResultModels(new ArrayList<BehaviorStatusCodeResultModel>());
		for (int i = 0; i < successCount; i++) {
			e.getDetailStatusCodeResultModels().add(
					new BehaviorStatusCodeResultModel(1, 200, 2, 10,
							"text/html", 320, 10, 190, 260, 450));
		}
		for (int i = 0; i < totalCount - successCount; i++) {
			e.getDetailStatusCodeResultModels().add(
					new BehaviorStatusCodeResultModel(1, 400, 2, 10,
							"text/html", 320, 10, 190, 260, 450));
		}
		e.setSuccessfulCount(successCount);
		e.setTotalCount(totalCount);
		return e;
	}
}
