package org.bench4q.monitor.api;

import java.util.HashMap;
import java.util.UUID;
import java.util.concurrent.ExecutionException;

import org.bench4q.monitor.model.LimitModel;
import org.bench4q.monitor.model.LimitableFieldsModel;
import org.bench4q.monitor.model.MonitorMain;
import org.hyperic.sigar.SigarException;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller
@RequestMapping("/monitor")
public class MainController {
	private HashMap<UUID, LimitModel> submitedLimits = new HashMap<UUID, LimitModel>();

	@RequestMapping("/all")
	@ResponseBody
	MonitorMain getMainModel() throws SigarException, InterruptedException,
			ExecutionException {
		MonitorMain retModel = new MonitorMain();
		return retModel;
	}

	@RequestMapping(value = "/limitableFields")
	@ResponseBody
	public LimitableFieldsModel limitableFields() {
		return new LimitableFieldsModel();
	}

	@RequestMapping(value = "/submitLimit/{testPlanId}", method = RequestMethod.PUT)
	@ResponseBody
	public String submitLimit(@PathVariable UUID testPlanId,
			@RequestBody LimitModel limits) {
		this.submitedLimits.put(testPlanId, limits);
		return testPlanId.toString();
	}

	@RequestMapping(value = "/brief/{testPlanId}", method = RequestMethod.GET)
	@ResponseBody
	MonitorMain brief(@PathVariable UUID testPlanId) throws SigarException,
			InterruptedException, ExecutionException {
		return new MonitorMain(this.submitedLimits.get(testPlanId));
	}
}
