var PiePoint = function(name, count, percentage) {
	this.name = name;
	this.count = count;
	this.percentage = percentage;	
}

var PieChart = function(chartId, title) {
	$('#' + chartId)
			.highcharts(
					{
						chart : {
							backgroundColor:'#fff',
							plotBackgroundColor : null,
							plotBorderWidth : null,
							plotShadow : false
						},
						title : {
							text : title,
							align: 'left'
						},
						tooltip : {
							pointFormat : '{series.name}: <b>{point.percentage:.1f}</b> %'
						},
						plotOptions : {
							pie : {
								size:250,
								allowPointSelect : true,
								cursor : 'pointer',
								dataLabels : {
									enabled : true,
									color : '#000000',
									connectorColor : '#000000',
									format : '<b>{point.name}</b>: {point.count} ({point.percentage:.1f}%)'
								}
							}
						},
						series : [ {
							type : 'pie',
							name : 'URL content type distribution',
							data : []
						} ]
					});

}

var UrlContentTypeDistribution = function(containerId, testPlanId) {
	var pieChart = new PieChart(containerId, "URL content type distribution");
	var chart = $("#" + containerId).highcharts();
	getUrlContentTypeData(testPlanId, chart);
}

var addPieData = function(chart,data){
	var points = contentTypeDataFormat(data);
	for(var i=0; i<points.length; i++){
		chart.series[0].addPoint({
	        name: points[i].name,
	        count: points[i].count,
	        y: points[i].percentage
	    });
	}
}

var getUrlContentTypeData = function (testPlanId, chart){
	$.post( testPlanId + "/" + "urlContentTypeCount", 
			{},
			function(data) {
				
				if (data.success) {
					addPieData(chart, data.result);
				} else {
					return;
				}
			}).error(function(){
				information($.i18n.prop('failed-connect-server'));
			});;
	
}

var contentTypeDataFormat = function (data){
	var points = new Array(); 
	var dataKeys = Object.keys(data);
	
	var sum=0;
	for( var i=0; i < dataKeys.length; i++){
		sum = sum + data[dataKeys[i]];
	}
	for( var i=0; i < dataKeys.length; i++){
		points[i] = new PiePoint(dataKeys[i], data[dataKeys[i]], data[dataKeys[i]]/sum);
	}
	return points;
	
}
